# Revision history for phonetic-languages-simplified-examples-array

## 0.1.0.0 -- 2021-01-02

* First version. Released on an unsuspecting world.

## 0.1.1.0 -- 2021-01-02

* First version revised A. Partially removed the unneeded dependency of mmsyn2.

## 0.1.2.0 -- 2021-01-02

* First version revised A. Removed the unneeded dependency of mmsyn2 (and all the vector-related functionality).
Some cabal file improvements.

## 0.2.0.0 -- 2021-01-04

* Second version. Added a comparative mode to the possibilities of the rewritePoemG3 and the Phonetic.Languages.Lines
 module. Some documentation improvements.

## 0.2.1.0 -- 2021-01-06

* Second version revised A. Added examples (in English) to the README.md file.

## 0.2.2.0 -- 2021-01-20

* Second version revised B. Removed the unneeded hidden dependencies of the vector related packages and functionality (that was
announced in the 0.1.2.0 version). Fully switched to the GHC.Arr arrays where needed.

## 0.3.0.0 -- 2021-01-28

* Third version. The package has the multiple variations mode for lineVariantsG3 executable that allows to use modifications in the text, e. g. synonyms, paraphrases etc. Added more variants of the properties based on the new dataset for
r-glpk-phonetic-languages-ukrainian-durations package. Added a new module Phonetic.Languages.Parsing for the new functionality. Removed unneeded print-info dependency.

## 0.4.0.0 -- 2021-02-01

* Fourth version. Added new line of rhythmicity evaluation functions ("z"-line). The behaviour of the previous functions also
changed, so it may be needed (in case where the results have some principal meaning, e. g. in scientific research,
not the text itself) to recalculate the results using these functions. Added the possibility to get the Ukrainian
informational messages during the work of the lineVariantsG3 executable (using the "+U" command line option not inside
the groups of options). Some documentation improvements.

## 0.4.0.1 -- 2021-04-17

* Fourth version revised A. Fixed some issues with README.md file. Updated the dependency boundaries for mmsyn2-array package.

## 0.4.1.0 -- 2021-04-19

* Fourth version revised B. Updated the Ukrainian documentation fixing some text issues. See README.md.

## 0.4.2.0 -- 2021-05-31

* Fourth version revised C. Added an English brief instructions to the package.

## 0.5.0.0 -- 2021-07-20

* Fifth version. Added two new lines ("w" and "x" lines) as a new properties evaluation strategies. Updated the dependencies
boundaries accordingly.

## 0.5.0.1 -- 2021-07-21

* Fifth version revised A. Changed the README.md file to the just README to fix the display of the command
line examples in it.

## 0.6.0.0 -- 2021-07-28

* Sixth version. Changed the command line arguments modifiers notation to the small letters,
removed the double ++ sign (changed to just single +) to simplify the command line arguments usage.
Also changed the way to sign the writing to file for the lineVariantsG3 executable. Added new lines of
properties for the (hypothetic) polyrhythmicity handling. Among them "c", "s", "t", "u", "v" lines are.
Changed the documentation appropriately. Changed the dependencies boundaries. Added the possibility to
'grow lines' for the rewritePoemG3 and propertiesTextG3 executables.

## 0.6.1.0 -- 2021-07-30

Sixth version revised A. Fixed issues with the fixed point of 1.0 (arising from the issue in the dependency package
phonetic-languages-rhythmicity).


## 0.6.2.0 -- 2021-07-31

* Sixth version revised B. Changed the dependency boundaries so that the issues are fixed with '0' and not '0' functions.
Some code improvements (reduced duplication).

## 0.7.0.0 -- 2021-08-09

* Seventh version. Changed the dependency boundaries so that now "c", "s", "t", "u", and "v" series of properties
can be negative by sign. This does not change the logics of the working programs and functions. Some documentation
improvements.

## 0.8.0.0 -- 2021-08-14

* Eigth version. Changed the dependency boundaries and added new weighted properties and fixed some issues with
the previous ones so that they use more complete information. Added the handler for the case of the empty line for
the lineVariantsG3 executable and related functionality. Some documentation improvements.

## 0.8.1.0 -- 2021-08-15

* Eigth version revised A. Fixed issue with the wrong order and, therefore, mapping for different choices and
the corresponding properties in the module Phonetic.Languages.Simplified.Array.Ukrainian.FuncRep2RelatedG2.

## 0.9.0.0 -- 2021-08-16

* Ninth version. Added new properties that try to increase the importance of the ending of the line and decrease
the importance of the beginning of the line. Added new dependency of string-interpreter. Added the possibility
to run lineVariantsG3 and the corresponding library functions in the recursive interactive mode. It is not
compatible with the contstraints so should be used not simultaneously with them (because they change their meaning).
Some documentation improvements.

## 0.10.0.0 -- 2021-08-17

* The tenth version. Added new linear weighted properties. Fixed some issues with wrong mapping. Some documentation
improvements.

## 0.10.1.0 -- 2021-08-24

* The tenth version revised. Fixed issues with the custom user defined polyrhythmicity patterns. Changed the
documentation instructions in editor. Updated the dependency boundaries accordingly.

## 0.11.0.0 -- 2021-09-04

* The eleventh version. Added new mode of multiple sources processment (+t_ ... -t). Added the possibility to
count in the recursive mode not just from the beginning of the word concatenation but also from the end using
the commonly used programming pattern of the negative integer indexing. Updated the dependencies so that now
it can use multiple improvements of the dependencies. Some documentation improvements.

## 0.11.0.1 -- 2021-09-06

* The eleventh version revised A. Fixed issue with documentation (README) file.

## 0.11.1.0 -- 2021-09-08

* The eleventh version revised B. Fixed issue with the phonetic-languages-plus dependency being not built. Updated
the dependency boundaries.

## 0.11.2.0 -- 2021-09-09

* The eleventh version revised C. Fixed issue with the phonetic-languages-ukrainian-array dependency being not
built. Updated the dependency boundaries. Updated the README file with the hyperlinks to the updated documentation
related to the usage of the package.

## 0.11.3.0 -- 2021-09-09

* The eleventh version revised D. Updated the README file with the hyperlinks to the updated documentation
related to the usage of the package.

## 0.12.0.0 -- 2021-09-14

* The twelth version. Added multiple properties mode to the rewritePoemG3 program and extended the comparative mode
for it up to 7 different input source files. Some documentation improvements.

## 0.12.1.0 -- 2021-09-15

* The twelth version revised A. Fixed issues in the documentation for the installation and upgrading processes.

## 0.13.0.0 -- 2021-10-14

* The thirteenth version. Added the possibility to provide the user-defined (read from the file with Haskell-like
syntaxis) functions to define the syllable durations. Added also the possibility to use just pairwise permutations
instead of the full universal set of them. Updated the dependency boundaries and the documentation
appropriately. Fixed the issue with not properly documented (re-)installation process for the package(s).

## 0.13.1.0 -- 2021-10-23

* The thirteenth version revised A. Imlemented pairwise permutations mode more deeply. Some documentation improvements.
Updated the dependencies boundaries.

## 0.14.0.0 -- 2021-10-31

* The fourteenth version. Fixed the not very sufficient release candidate that used hashing functionality. If you have not
upgraded to the hashing functionality during the 2021-10-30--2021-10-31 you do not need to upgrade either.
